# NGT Demonstrator

[[_TOC_]]

## Online Demo
For an online demo visit: https://inno_sc_vcts.pages.gitlab.dlr.de/exponat-2020

It may contain some bugs which are not present in the desktop version. Especially the speed limits scenario isn't working right now. 

## Licensing

The source code is licensed under the MIT License, which you can find [here](LICENSE.txt).

Since the application links to Qt-Modules, which are available only under GPLv3, the binaries of the NGT Demonstrator are licensed under GPLv3 license as well.

## Download prebuild binaries
1. To download the latest build you go to CI/CD on the left side:
![](docs/CI-CD.png)
2. Here you can download the latest binaries, by clicking the buttons (2) and (3) in the top most row, where **passed** is written on the left side (1):
![](docs/Download.png)
3. Extract the downloaded `artifacts.zip` archive
4. Execute the `ngt_demonstrator.exe` in `artifacts\install\exponat-2020`:
![](docs/Start.png)

## Building and Running from Source

#### Prerequisites
- [CMake 3.16+](https://cmake.org/download/)
- [Qt5 5.15](https://www.qt.io/download-qt-installer?hsCtaTracking=99d9dd4f-5681-48d2-b096-470725510d34%7C074ddad0-fdef-4e53-8aa8-5e8a876d6ab4)
- A compiler that supports C++17.

### Windows
**Compilers:**

- Microsoft Visual Studio 2017+
- MinGW 64 bit with gcc 8.1+ (e.g: https://www.msys2.org/)

**Building the Application:**

Before building the main application you need to make sure that the Qt5 installation can be found.
This can be achieved by setting the environment variable: `QT5_ROOT_DIR`

You can achieve this by either setting it globally through the system or user environment variable or by setting it before building in the command line.
For example:

```bash
# For MinGW
set QT5_ROOT_DIR=<path to qt5 installation>/Qt5/5.15.0/mingw73_64

# For Visual Studio 2017 & 2019
set QT5_ROOT_DIR=<path to qt5 installation>/Qt5/5.15.0/msvc2017_64
``` 

To build the application you can use the `make.bat` script. 
It accepts arguments which are forwarded to CMake, like changing the generator.

```bash
# Visual Studio 2017 (default)
make.bat

# Visual Studio 2019
make.bat -G "Visual Studio 16 2019" -A x64

# MinGW with GCC
make.bat -G "MinGW Makefiles"
```

**Running the Application:**

The binaries can be found in `install\windows-release`.
You can just run the `ngt_demonstrator.exe`. 

---

### Linux
TODO
