import QtQuick 2.15
import QtQuick.Controls 2.14
import "../theme"

Button {
   id: dlrButtonRoot
   implicitWidth: 250

   background: Rectangle {
      width: parent.width
      height: parent.height
      radius: 5
      color: parent.checked ? DLRTheme.teaserBlue : (parent.hovered ? DLRTheme.highlightBlue : DLRTheme.backgroundBlue)
      border.color: DLRTheme.textBlack
      border.width: parent.checked ? 2 : 1
   }

   font.family: "Arial"
   font.pointSize: 16
   property var fontSizeMode: Text.FixedSize
   property var wrapMode: Text.NoWrap
   property var horizontalAlignment: Text.AlignHCenter

   contentItem: Row {
      padding: 0
      spacing: 2

      Image {
         id: buttonIcon
         property bool exists: !!dlrButtonRoot.icon.source.toString()
         width: exists ? dlrButtonRoot.icon.width || 0 : 0
         height: exists ? dlrButtonRoot.icon.height || 0 : 0
         sourceSize.width: width
         sourceSize.height: height
         source: dlrButtonRoot.icon.source
         cache: dlrButtonRoot.icon.cache
      }

      Text {
         width: parent.width - buttonIcon.width

         horizontalAlignment: dlrButtonRoot.horizontalAlignment
         verticalAlignment: Text.AlignVCenter
         text: dlrButtonRoot.text
         font: dlrButtonRoot.font
         fontSizeMode: dlrButtonRoot.fontSizeMode
         wrapMode: dlrButtonRoot.wrapMode
         minimumPixelSize: -1
         minimumPointSize: -1
      }
   }

   MouseArea {
      anchors.fill: parent
      cursorShape: Qt.PointingHandCursor
      acceptedButtons: Qt.NoButton
      Component.onCompleted: if (appInfo.isWeb()) { visible = false; }
   }
}