import QtQuick 2.15
import QtQuick.Controls 2.15

import "../theme"

Slider {
   id: control
   property var postfix: ""
   property var precision: 1

   background: Rectangle {
      x: control.leftPadding
      y: control.topPadding + control.availableHeight / 2 - height / 2
      implicitWidth: 200
      implicitHeight: 8
      width: control.availableWidth
      height: implicitHeight
      radius: 4
      color: DLRTheme.backgroundLightGrey
      border.color: DLRTheme.backgroundWhite

      Rectangle {
         width: control.visualPosition * parent.width
         height: parent.height
         color: DLRTheme.backgroundBlue
         radius: 4
      }
   }

   handle: Rectangle {
      x: control.leftPadding + control.visualPosition * (control.availableWidth - width)
      y: control.topPadding + control.availableHeight / 2 - height / 2
      implicitWidth: 36
      implicitHeight: 36
      radius: 18
      color: control.pressed ? DLRTheme.teaserBlue : DLRTheme.highlightBlue
      border.color: DLRTheme.backgroundLightGrey

      DLRLabel {
         anchors.centerIn: parent
         width: parent.width - 4
         height: parent.height - 4
         text: control.value.toFixed(precision) + postfix
         minimumPointSize: 4
         fontSizeMode: Text.Fit
         verticalAlignment: Text.AlignVCenter
         horizontalAlignment : Text.AlignHCenter
         wrapMode: Text.WordWrap
      }

      MouseArea {
         anchors.fill: parent
         cursorShape: control.pressed ? Qt.ClosedHandCursor : Qt.OpenHandCursor
         acceptedButtons: Qt.NoButton
         Component.onCompleted: if (appInfo.isWeb()) { visible = false; }
      }
   }

   MouseArea {
      anchors.fill: parent
      cursorShape: Qt.PointingHandCursor
      acceptedButtons: Qt.NoButton
      Component.onCompleted: if (appInfo.isWeb()) { visible = false; }
   }
}
