import QtQuick 2.14
import QtQuick.Controls 2.14
import QtQuick.Layouts 1.14

import "../theme"

Column {
   id: valueSliderRoot
   property string title
   property string unit

   property real start
   property real current
   property real end

   property real step

   property real precision: (step % 1 === 0) ? 0 : 1

   property string tooltipText: ""

   height: childrenRect.height

   Row {
      x: 10
      spacing: 10

      InfoPopup {
         tooltipText: valueSliderRoot.tooltipText
      }

      DLRLabel {
         anchors.verticalCenter: parent.verticalCenter
         id: titleText
         text: title
         font.pointSize: 12
      }
   }

   Row {
      width: parent.width

      DLRSlider {
         id: valueSlider
         width: parent.width
         anchors.verticalCenter: parent.verticalCenter

         from: start
         value: current
         to: end
         stepSize: step
         postfix: unit === "" ? "" : "\u2009" + unit
         precision: valueSliderRoot.precision

         Binding {
            target: valueSliderRoot
            property: "current"
            value: valueSlider.value
         }
      }
   }
}