import QtQuick 2.14
import ".."
import "../../theme"
import "../../components"

Item {
   property string name
   property bool displayName
   property bool showLeft

   property real latitude
   property real longitude

   property real centerX: xFromLong(longitude)
   property real centerY: yFromLat(latitude)

   property real zoomScale: 1

   z: 20

   Rectangle {
      z: parent.z
      id: circle
      radius: 5 * zoomScale
      x: centerX - radius
      y: centerY - radius
      color: DLRTheme.teaserYellow
      border.color: "black"
      width: 2 * radius
      height: 2 * radius

      scale: widgetScale
      transformOrigin: Item.Center
   }

   DLRLabel {
      visible: displayName && showLeft
      text: name
      anchors {
         right: circle.left
         verticalCenter: circle.verticalCenter
         rightMargin: 10 * widgetScale
      }
      scale: widgetScale
      transformOrigin: Item.Right
   }

   DLRLabel {
      visible: displayName && !showLeft
      text: name
      anchors {
         left: circle.right
         verticalCenter: circle.verticalCenter
         leftMargin: 10 * widgetScale
      }
      scale: widgetScale
      transformOrigin: Item.Left
   }

   transform: Rotation { origin.x: centerX; origin.y: centerY; angle: 0 }
}