import QtQuick 2.14
import QtQuick.Controls 2.14
import QtQuick.Layouts 1.14
import QtQuick.Window 2.15
import QtQuick.Extras 1.4

import "components"
import "theme"
import "slip-coaching/simulation-ssc.mjs" as NGT

Item {
   id: view
   signal returnToOverview()

   DLRLabel {
      id: titleLabel

      scale: widgetScale
      transformOrigin: Item.Top

      anchors {
         top: parent.top
         topMargin: verticalMargin
         horizontalCenter: parent.horizontalCenter
      }

      text: "Slip Coaching"
      font.pointSize: 40
      font.bold: true
      z: 1000
   }

   Loader {
      id: slipCoachingLoader
      source: "slip-coaching/" + (slipCoachingGroup.checkedButton.ssc ? "single" : "double") + "-slip-coaching.qml"

      anchors {
         fill: parent
      }

      clip: true
   }

   ButtonGroup {
      id: slipCoachingGroup
      exclusive: true
   }

   Column {
      id: slipCoachingSwitch
      scale: widgetScale
      transformOrigin: Item.TopLeft
      width: 250
      spacing: 5

      anchors {
         top: parent.top
         left: parent.left
         leftMargin: horizontalMargin
         topMargin: verticalMargin + (titleLabel.height * widgetScale) + titleLabel.anchors.topMargin
      }

      DLRButton {
         checked: true
         checkable: true
         text: "Single Slip Coaching"
         ButtonGroup.group: slipCoachingGroup
         width: parent.width
         property bool ssc: true
      }

      DLRButton {
         text: "Double Slip Coaching"
         checkable: true
         ButtonGroup.group: slipCoachingGroup
         width: parent.width
         property bool ssc: false
      }
   }
}