import QtQuick 2.14
import QtQuick.Layouts 1.14

Item {
   id: foreground
   readonly property int maxImages: 100 / imageWidthKM

   readonly property real imageScale: 3
   readonly property real scaledImageWidth: imageScale * imageWidth

   readonly property real imageWidthKM: imageScale * 0.240 // km
   readonly property real maxWidthKM: maxImages * imageWidthKM // km


   width: scaledImageWidth * maxImages
   height: pixelLength(imageWidthKM) / (16 / 9)

   function getForegroundRandomImage() {
      return "../../images/parallax/Foreground-" + Math.floor(Math.random() * 4 + 1) + ".webp"
   }

   function getBackgroundRandomImage() {
      return "../../images/parallax/Background-" + Math.floor(Math.random() * 4 + 1) + ".webp"
   }

   Repeater {
      id: foregroundImages
      model: maxImages
      Item {
         x: pixelPosition(index * imageWidthKM) - pixelLength(10)
         width:  pixelLength(imageWidthKM)
         anchors.bottom: parent.bottom

         Image {
            source: foreground.getForegroundRandomImage()
            asynchronous: true
            anchors.bottom: parent.bottom
            width: parent.width
            fillMode: Image.PreserveAspectFit
            mipmap: true
         }
      }
   }
}