import QtQuick 2.14
import QtQuick.Controls 2.14
import QtQuick.Layouts 1.14

import "../components"
import "../theme"

Column {
   Repeater {
      model: speedLimitsModel.nextTrack
      delegate: Row {
         width: parent.width / 2

         ValueSlider {
            id: limitSlider
            width: parent.width

            title: "Section " + (index + 1)
            unit: "\nkm/h"
            tooltipText: "Here you can vary the speed that should apply on the respective section of the route."

            start: model.minSpeed
            current: model.speedLimit
            end: model.maxSpeed
            step: 10

            Binding {
               target: model
               property: "speedLimit"
               value: limitSlider.current
            }
         }
      }
   }
}