import QtQuick 2.14
import QtQuick.Controls 2.14
import QtQuick.Layouts 1.14

import "../components"
import "../theme"

Row {
   function setSpeed(speed) {
      simulationSpeedSlider.current = speed
   }

   ValueSlider {
      id: simulationSpeedSlider
      width: parent.width - rewindButton.width
      title: "Simulation Speed"
      unit: "x"

      start: 0
      current: 0
      end: 100
      step: 1

      Binding {
         target: speedLimitsModel
         property: "simulationSpeed"
         value: simulationSpeedSlider.current
      }
   }

   DLRButton {
      id: rewindButton
      icon.source: "../../icons/rewind.png"
      onClicked: speedLimitsModel.nextRun();
      width: height + 4

      anchors {
         bottom: parent.bottom
         bottomMargin: 8
      }
   }
}