import QtQuick 2.14
import QtQuick.Controls 2.14
import QtQuick.Layouts 1.14

import "../components"
import "../theme"

Column {
   ValueSlider {
      id: trainLengthSlider
      width: parent.width

      title: "Train Length"
      unit: "m"
      tooltipText: "Here you can adjust the train length of each train unit."

      start: 100
      current: 200
      end: 300
      step: trainSegmentLength

      Binding {
         target: speedLimitsModel
         property: "trainLength"
         value: trainLengthSlider.current
      }
   }

   ValueSlider {
      id: numTrainsSlider
      width: parent.width

      title: "Number of Trains"
      unit: ""
      tooltipText: "Here you can adjust the number of train units per train set."

      start: 2
      current: 4
      end: 6
      step: 1

      Binding {
         target: speedLimitsModel
         property: "numTrains"
         value: numTrainsSlider.current
      }
   }
}