import QtQuick 2.14

import "../../components"
import "../../theme"

Item {
   property real start
   property real length
   property real pHeight
   property real yPos

   property var circleColor

   property real speed

   property int numberOfTrains
   property int numberOfSegments

   property string labelPos

   Repeater {
      model: numberOfTrains
      anchors.bottom: parent.bottom
      delegate: Repeater {
         property int trainIdx: index
         model: numberOfSegments
         delegate: Image {
            width: (length / numberOfTrains) / numberOfSegments
            height: Math.max(pHeight, 2)
            x: start - length + (trainIdx * (length / numberOfTrains)) + (index * width)
            source: "../../../images/HST_" + (index == 0 ? "Back" : index == numberOfSegments - 1 ? "Front" : "Middle") + ".png"
            mipmap: true
            smooth: false
            anchors.bottom: parent.bottom

            Circle {
               readonly property var maxOpacity: 4
               readonly property var opacityRange: 3

               transformOrigin: Item.Center
               scale: widgetScale

               visible: pHeight < maxOpacity + opacityRange
               radius: 5
               centerX: parent.width / 2
               centerY: parent.height / 2
               color: circleColor
               opacity: 1 - ((pHeight - maxOpacity) / opacityRange)
            }
         }
      }
   }

   DLRLabel {
      text: speed + " km/h"
      color: DLRTheme.textWhite
      x: start - (length / 2) - (width / 2)
      y: labelPos === "bottom" ? height * 1.5 : -height * 3
   }
}