#pragma once

#include "si.hpp"
#include "todo.hpp"

#include <glm/glm.hpp>
#include <ostream>

namespace ngt {

struct Coordinates {
    double latitude;
    double longitude;

    Coordinates(double latitude, double longitude)
        : latitude(latitude)
        , longitude(longitude) {}

    explicit Coordinates(glm::dvec2 const& coords)
        : latitude(coords.x)
        , longitude(coords.y) {}

    [[nodiscard]]
    auto toVec2() const -> glm::dvec2 { return {latitude, longitude}; }

    friend auto operator<<(std::ostream& os, Coordinates const& coordinates) -> std::ostream& {
        os << "latitude: " << coordinates.latitude << "° longitude: " << coordinates.longitude << "°";
        return os;
    }
};

} // namespace ngt