#pragma once

#include <QtCore/QFile>
#include <QtCore/QTextStream>
#include <spdlog/spdlog.h>

namespace ngt::io {
class FileReader : public QObject {
   Q_OBJECT; // NOLINT
 public:
   [[maybe_unused]]
   Q_INVOKABLE QString readFile(const QString& fileName) {
      QFile qfile(fileName);
      if (!qfile.open(QIODevice::ReadOnly)) {
         spdlog::critical("Can't open resource file: {}", fileName.toStdString());
      }

      QTextStream is(&qfile);
      is.setCodec("UTF-8");
      return is.readAll();
   }
};
} // namespace ngt::io