#pragma once

namespace ngt::utils {

#ifdef NDEBUG
const bool DEBUG_ENABLED = false;
#else
const bool DEBUG_ENABLED = true;
#endif

/// Can be used to check the operating system at compile time.
enum class Platform { Linux, Windows, Web };

#ifdef __EMSCRIPTEN__
constexpr Platform HostPlatform = Platform::Web;
#elif __linux__
constexpr Platform HostPlatform = Platform::Linux;
#elif _WIN32
constexpr Platform HostPlatform = Platform::Windows;
#endif

} // namespace ngt::utils