#include "io.hpp"

#include <QtCore/QFile>
#include <QtCore/QTextStream>
#include <spdlog/spdlog.h>

namespace ngt::io {

auto loadJson(std::string_view file) -> nlohmann::json {
   QFile qfile(file.data());
   if (!qfile.open(QIODevice::ReadOnly)) {
      spdlog::critical("Can't open resource file: {}", file);
   }

   QTextStream is(&qfile);
   is.setCodec("UTF-8");
   std::string contents = is.readAll().toStdString();
   return nlohmann::json::parse(contents);
}

} // namespace ngt::io
