#pragma once

#include "Coordinates.hpp"

#include <nlohmann/json.hpp>
#include <units.h>

using namespace units::literals; // NOLINT(google-build-using-namespace, google-global-names-in-headers)

namespace si {
using namespace units;               // NOLINT(google-build-using-namespace)
using namespace units::length;       // NOLINT(google-build-using-namespace)
using namespace units::velocity;     // NOLINT(google-build-using-namespace)
using namespace units::acceleration; // NOLINT(google-build-using-namespace)
using namespace units::angle;        // NOLINT(google-build-using-namespace)
using namespace units::time;         // NOLINT(google-build-using-namespace)
using namespace units::mass;         // NOLINT(google-build-using-namespace)
using namespace units::power;        // NOLINT(google-build-using-namespace)

template <typename Unit>
auto parse(nlohmann::json const& j, std::string_view key) -> Unit {
    return make_unit<Unit>(j.at(key.data()).get<double>());
}

} // namespace si
