#pragma once

#include <map>
#include <ngt/views/overview/model/Station.hpp>
#include <ngt/views/overview/model/TrackNode.hpp>
#include <ngt/views/overview/model/TrackSegment.hpp>
#include <ngt/views/overview/model/Train.hpp>
#include <ngt/views/overview/model/TrainData.hpp>
#include <string_view>
#include <vector>

namespace ngt::overview {

using StationList = std::vector<Station>;
using NodeMap     = std::unordered_map<std::string, TrackNode>;
using TrackMap    = std::unordered_map<std::string, TrackSegment>;

auto loadTrainNetwork(std::string_view file) -> std::tuple<StationList, NodeMap, TrackMap>;
auto loadTrainData(std::string_view file)
   -> std::pair<std::unordered_map<std::string, TrainData>, std::chrono::milliseconds>;
auto loadTrains(std::string_view file) -> std::vector<Train>;

} // namespace ngt::overview
