#pragma once

#include <nlohmann/json.hpp>

#include <cstdint>
#include <string>

namespace ngt::overview::json {

struct Train {
   std::string id;
   uint32_t    waggons{0};
};

struct Node {
   std::string               name;
   std::string               shortName;
   std::pair<double, double> coordinates;
   bool                      isStation{false};
   bool                      displayName{false};
   bool                      left{false};
};

struct Edge {
   std::string id;
   double      length{0};
   std::string start;
   std::string end;
};

struct TimeStamp {
   double      time{0};
   std::string edge;
   double      edgePosition{0};
};

struct TrainPositions {
   std::string            trainId;
   std::vector<TimeStamp> timeStamps;
};

/* ################################################################################################################## */

void from_json(nlohmann::json const& j, Train& t);
void from_json(nlohmann::json const& j, Node& n);
void from_json(nlohmann::json const& j, Edge& e);
void from_json(nlohmann::json const& j, TimeStamp& t);
void from_json(nlohmann::json const& j, std::map<std::string, TrainPositions>& t);

}; // namespace ngt::overview::json