#pragma once

#include <fstream>
#include <ngt/utils/Coordinates.hpp>
#include <ostream>
#include <utility>

namespace ngt::overview {

struct Station {
   Station(std::string_view name, std::string_view shortName, Coordinates const& location, bool displayName, bool left)
      : name(name)
      , shortName(shortName)
      , coordinates(location)
      , displayName(displayName)
      , left(left) {}

   std::string name;
   std::string shortName;
   Coordinates coordinates;
   bool        displayName;
   bool        left;

   friend auto operator<<(std::ostream& os, Station const& station) -> std::ostream& {
      os << "name: " << station.name << " coordinates: " << station.coordinates;
      return os;
   }
};

} // namespace ngt::overview