#pragma once

#include <ostream>

#include <ngt/utils/Coordinates.hpp>

namespace ngt::overview {

struct TrackNode {
   TrackNode(std::string_view id, Coordinates const& location)
      : id(id)
      , coordinates(location) {}

   std::string const id;
   Coordinates const coordinates;

   friend auto operator<<(std::ostream& os, TrackNode const& node) -> std::ostream& {
      os << "id: " << node.id << " location: " << node.coordinates;
      return os;
   }
};

} // namespace ngt::overview