#pragma once

#include <ostream>
#include <utility>

#include "TrackNode.hpp"

namespace ngt::overview {
struct TrackSegment {
   TrackSegment(std::string id, TrackNode start, TrackNode end, double length)
      : id(std::move(id))
      , start(std::move(start))
      , end(std::move(end))
      , length(length) {}

   std::string     id;
   TrackNode const start;
   TrackNode const end;
   double const    length;

   friend auto operator<<(std::ostream& os, TrackSegment const& segment) -> std::ostream& {
      os << "id: " << segment.id << " start: " << segment.start << " end: " << segment.end
         << " length: " << segment.length;
      return os;
   }
};
} // namespace ngt::overview