#pragma once

#include <QtCore/QAbstractListModel>
#include <ngt/views/overview/model/Station.hpp>

namespace ngt::overview {

class StationListViewModel : public QAbstractListModel {
   Q_OBJECT; // NOLINT

 public:
   explicit StationListViewModel(std::vector<Station> const* stations = nullptr);

   StationListViewModel(StationListViewModel const& other) = delete;
   auto operator=(StationListViewModel const& other) -> StationListViewModel&;

   StationListViewModel(StationListViewModel&& other) = delete;
   auto operator=(StationListViewModel&& other) -> StationListViewModel& = delete;

   ~StationListViewModel() override = default;

   [[nodiscard]]
   auto rowCount(QModelIndex const& parent) const -> int override;

   [[nodiscard]]
   auto data(const QModelIndex& index, int role) const -> QVariant override;

   [[nodiscard]]
   auto roleNames() const -> QHash<int, QByteArray> override;

 private:
   std::vector<Station> const* stations;

   enum { Latitude = Qt::UserRole, Longitude, Name, ShortName, DisplayName, Left };
};

} // namespace ngt::overview