#pragma once

#include <QtCore/QAbstractListModel>
#include <ngt/views/overview/model/TrackSegment.hpp>

namespace ngt::overview {

class TrackSegmentListViewModel : public QAbstractListModel {
   Q_OBJECT; // NOLINT
 public:
   explicit TrackSegmentListViewModel(std::unordered_map<std::string, TrackSegment> const* trackSegments = nullptr);

   TrackSegmentListViewModel(TrackSegmentListViewModel const& other) = delete;
   auto operator=(TrackSegmentListViewModel const& other) -> TrackSegmentListViewModel&;

   TrackSegmentListViewModel(TrackSegmentListViewModel&& other) = delete;
   auto operator=(TrackSegmentListViewModel&& other) -> TrackSegmentListViewModel& = delete;

   ~TrackSegmentListViewModel() override = default;

   [[nodiscard]]
   auto rowCount(QModelIndex const& parent) const -> int override;

   [[nodiscard]]
   auto data(const QModelIndex& index, int role) const -> QVariant override;

   [[nodiscard]]
   auto roleNames() const -> QHash<int, QByteArray> override;

   [[nodiscard]]
   auto getTrack(std::string const& id) -> TrackSegment const& { return trackSegments->at(id); }

 private:
   std::unordered_map<std::string, TrackSegment> const* trackSegments;
};

} // namespace ngt::overview