#pragma once

#include <QtCore/QAbstractListModel>

#include <ngt/views/overview/model/Train.hpp>

namespace ngt::overview {

class TrainListViewModel : public QAbstractListModel {
   Q_OBJECT; // NOLINT
 public:
   explicit TrainListViewModel(std::vector<Train>* trains = nullptr);

   TrainListViewModel(TrainListViewModel const& other) = delete;
   auto operator                                       =(TrainListViewModel const& other) -> TrainListViewModel&;

   TrainListViewModel(TrainListViewModel&& other) = delete;
   auto operator=(TrainListViewModel&& other) -> TrainListViewModel& = delete;

   ~TrainListViewModel() override = default;

   [[nodiscard]]
   auto rowCount(QModelIndex const& parent) const -> int override;

   [[nodiscard]]
   auto data(const QModelIndex& index, int role) const -> QVariant override;

   [[nodiscard]]
   auto roleNames() const -> QHash<int, QByteArray> override;

   void changeEvent();

 private:
   std::vector<Train>* trains;
};

} // namespace ngt::overview