#pragma once

#include <nlohmann/json.hpp>

#include <ngt/utils/io.hpp>
#include <ngt/views/speed-limits/model/Track.hpp>
#include <ngt/views/speed-limits/model/Train.hpp>

namespace ngt::speedlimits {

struct Settings {
   TrainProperties trainProperties;
   Track           track;
};

[[nodiscard]]
auto loadFromJson(std::string_view file) -> Settings;

void from_json(nlohmann::json const& j, TrainProperties& trainProperties);
void from_json(nlohmann::json const& j, TrackSection& section);

} // namespace ngt::speedlimits