#pragma once

#include <ngt/utils/si.hpp>

namespace ngt::speedlimits {

struct TrainProperties {
   uint8_t wagons = 4U;

   si::meter_t vctsMinDistance = 120_m;
   si::meter_t length          = 200_m;

   si::meters_per_second_squared_t acceleration = 1_mps_sq;
   si::meters_per_second_squared_t deceleration = -1_mps_sq;
};

struct Train {
   Train() = default;

   Train(si::kilometer_t position, si::kilometers_per_hour_t speed, si::meter_t length)
      : position(position)
      , speed(speed)
      , length(length) {}

   si::kilometer_t           position{};
   si::kilometers_per_hour_t speed{};

   si::meter_t length{};

   [[nodiscard]]
   auto stopped() const noexcept -> bool { return speed <= 0_kph; }
};

} // namespace ngt::speedlimits